Subject: Re: [RFC] reset --hard: warn before discarding staged content with no commit history

From: Junio C Hamano <[email-masked]>
Date: Thu, 11 Dec 2025 14:25:35 +0900

Eric Sunshine <[email-masked]> writes:

> On Wed, Dec 10, 2025 at 10:24 PM Junio C Hamano <[email-masked]> wrote:
>> Koutsouflakis Stefanos <[email-masked]> writes:
>> > When running "git reset --hard" in a repository where staged
>> > content has never been committed, the staged files are lost. This
>> > seems like a case where requiring --force could be helpful.
>>
>> The thinking has always been "'--hard' means what it says!  HARD
>> removes things harder than other modes---there is need to add
>> '--force' to it".
>
> Presumably, you meant "there is *no* need" rather than "there is need".

Thanks.  I rewrote the paragraph a few times and somehow losing the
crucial negation from there..